/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var strings;


function init(grow)
{
    strings = document.getElementById("strings");

    var synclocal;
    var localpath;

    var syncremote;
    var syncprotocol;
    var synchost='';
    var syncuser='';
    var syncpassword='';
    var syncpath='';
    var autoupload=false;
    var autodownload=false;
    var hidepopups=false;

    try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); } catch(e){ synctype='none'; }

    try{ localpath = pref.getCharPref( "extensions.addressbookssync.localpath" ); } catch(e){ localpath=''; }

    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); } catch(e){}
    try{ synchost = pref.getCharPref( "extensions.addressbookssync.host" ); } catch(e){}
    try{ syncuser = pref.getCharPref( "extensions.addressbookssync.user" ); } catch(e){}
    //try{ syncpassword = get_password(synchost, syncuser); } catch(e){}
    syncpassword = '****************';
    try{ syncpath = pref.getCharPref( "extensions.addressbookssync.path" ); } catch(e){}

    try{ autoupload = pref.getBoolPref( "extensions.addressbookssync.autoupload" ); } catch(e){}
    try{ autodownload = pref.getBoolPref( "extensions.addressbookssync.autodownload" ); } catch(e){}

    if (synctype=='local')
      document.getElementById("synctype").selectedItem=document.getElementById("synclocal")
    else if (synctype=='remote')
      document.getElementById("synctype").selectedItem=document.getElementById("syncremote")

    document.getElementById("localpath").value = localpath;

    document.getElementById("protocol").value = syncprotocol;
    document.getElementById("host").value = synchost;
    document.getElementById("username").value = syncuser;
    document.getElementById("password").value = syncpassword;
    document.getElementById("path").value = syncpath;

    document.getElementById("autoupload").checked = autoupload;
    document.getElementById("autodownload").checked = autodownload;


    // list address books
    var mabList = document.getElementById("MabList");
    var syncList = document.getElementById("SyncListCheck");
    var listheight=document.getElementById("SyncList").boxObject.height;
    //just in case
    mabList.removeAllItems();
    while (syncList.firstChild)
      syncList.removeChild(syncList.firstChild);

    // get all MAB File
    var cn = directory.childNodes;
    var aBook = cn.getNext();
    var selectedMAB='';
    while( aBook != null )
    {
        var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
        var mabFile=cur.directoryProperties.fileName;
        var dirType = cur.directoryProperties.dirType;
        var description=cur.directoryProperties.description;
//        var uri = cur.directoryProperties.URI;

        mabList.appendItem( description, mabFile, "" ); // 'Store'

        //'Sync'
        var sync=false;
//        if (uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI && dirType==2) {
            // ignore history and pab and ldap-addressbooks
        if (dirType==2) {
          var ncb=document.createElement('checkbox');
          ncb.setAttribute('id', 'addressbookssync_'+description);
          ncb.setAttribute('label', description);
          syncList.appendChild( ncb );

          var prefName = cur.directoryProperties.prefName;
          try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync" ); } catch(e) { sync=false; }
          if (sync) {
            ncb.setAttribute('checked', true);
            selectedMAB=description;
          }
        }
        try { aBook = cn.getNext(); } catch(e) { break; } // catch
    } // while
    mabList.selectedIndex = 0;

    if (!selectedMAB) selectedMAB='???';
    selectedMAB+='.mab';
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB;

    try{ hidepopups = pref.getBoolPref( "extensions.addressbookssync.hidepopups" ); } catch(e){ hidepopups=false; }
    document.getElementById("hidepopups").checked = hidepopups;

    //on first call, height is about 27px (the window in not drawn yet)
    //on later calls (when we've added somthing to 'syncList'), its about 584px)
    var newlistheight=document.getElementById("SyncList").boxObject.height;
    if (grow) window.outerHeight+=newlistheight-listheight;
} // init



function finish()
{
    if (!document.getElementById("localpath")) return;  // called via toolbar buttons

    var localpath=document.getElementById("localpath").value;
    pref.setCharPref( "extensions.addressbookssync.localpath", localpath );
    if ( document.getElementById("synclocal").selected && localpath)
      pref.setCharPref( "extensions.addressbookssync.synctype", 'local' );
    else if ( document.getElementById("syncremote").selected )
      pref.setCharPref( "extensions.addressbookssync.synctype", 'remote' );
    else {
      pref.setCharPref( "extensions.addressbookssync.synctype", 'none' );
      document.getElementById("synctype").selectedItem=null;
    }

    pref.setBoolPref( "extensions.addressbookssync.syncremote", document.getElementById("syncremote").selected );
    pref.setCharPref( "extensions.addressbookssync.protocol", document.getElementById("protocol").value );
    var host=document.getElementById("host").value;  pref.setCharPref( "extensions.addressbookssync.host", host );
    var user=document.getElementById("username").value; pref.setCharPref( "extensions.addressbookssync.user", user );
    var pwd=document.getElementById("password").value;
    if (pwd!='****************') set_password(host,user,document.getElementById("password").value );
    pref.setCharPref( "extensions.addressbookssync.path", document.getElementById("path").value );
    pref.setBoolPref( "extensions.addressbookssync.autoupload", document.getElementById("autoupload").checked );
    pref.setBoolPref( "extensions.addressbookssync.autodownload", document.getElementById("autodownload").checked );

    var cn = directory.childNodes;
    var aBook = cn.getNext();
    var selectedMAB='';
    while( aBook != null )
    {
      var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
      var mabFile=cur.directoryProperties.fileName;
      var dirType = cur.directoryProperties.dirType;
      var description=cur.directoryProperties.description;
//      var uri = cur.directoryProperties.URI;
      var sync;
//      if (uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI && dirType==2) {
          // ignore history and pab and ldap-addressbooks
      if (dirType==2) {
        var syncElem = document.getElementById('addressbookssync_'+description);

        if (syncElem.getAttribute('checked')) {
          pref.setBoolPref( cur.directoryProperties.prefName+".extensions.addressbookssync", true );
          selectedMAB=description;
        } else
          pref.setBoolPref( cur.directoryProperties.prefName+".extensions.addressbookssync", false );
      }
      try { aBook = cn.getNext(); } catch(e) { break; } // catch
    }
    if (!selectedMAB) selectedMAB='???';
    selectedMAB+='.mab';
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB;

    pref.setBoolPref( "extensions.addressbookssync.hidepopups", document.getElementById("hidepopups").checked );
} // finish



function ChooseFile()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  var x=strings.getString("choosefile");
  filePicker.init(window, x, nsIFilePicker.modeOpen);
  filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "MabFilePath" ).value = filePicker.file.path;
    var mabFileName = filePicker.file.leafName;
    var mabName = mabFileName.substr( 0, mabFileName.lastIndexOf(".") );
    mabName = mabName.replace( /_/g, " " );
    document.getElementById( "MabName" ).value = mabName;
  }
} // ChooseFile

function ChoosePath()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  filePicker.init(window, strings.getString("choosesyncdir"), nsIFilePicker.modeGetFolder);

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "localpath" ).value = filePicker.file.path;
    document.getElementById( "synclocal" ).selected=true;
  }
} // ChoosePath


function SaveMab()
{
    var mabFile = document.getElementById( "MabList" ).selectedItem.value;
    var mabName = document.getElementById( "MabList" ).selectedItem.label;

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    var externMabFileName = mabName.replace( /\W/g, "_" ) + ".mab";
    filePicker.defaultString = externMabFileName;
    filePicker.init(window, strings.getString("choosefiledest"), nsIFilePicker.modeSave);
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

    if( filePicker.show() != nsIFilePicker.returnCancel) { //Ok or Replace!
      if (saveMabFile( mabName, mabFile, filePicker.file.parent, filePicker.file.leafName ))
        alert(strings.getString('stored'));
      else
        alert(strings.getString('storefailed'));
    }
} //


function LoadMab()
{
  var filename = document.getElementById( "MabFilePath" ).value;
  if (!filename) return;

  var mabName = document.getElementById( "MabName" ).value;
  if (!mabName) return;

  var cn = directory.childNodes;
  var aBook = cn.getNext();
  var mabFile='';
  var create;

  var cur=getAddressBook(mabName);
  if (cur) {
    mabFile=cur.directoryProperties.fileName;
//    if (uri==kPersonalAddressbookURI || uri==kCollectedAddressbookURI) {
//      alert(strings.getString('nooverwrite'));
//      return;
//    }
    if (!confirm(strings.getString('askoverwrite'))) return;
    create=false;
  } else {
    //create mabFile name
    mabFile = mabName.replace( /\W/g, "_" );
    mabFile += '.mab';
    createAddressBook( mabName, mabFile, false );
    create=true;
  }
  if (loadMabFile(mabName, mabFile, null, filename)) {
    document.getElementById( "MabFilePath" ).value='';
    document.getElementById( "MabName" ).value='';
    if (create) init(true);
    alert(strings.getString('loaded'));
  } else {
    alert(strings.getString('loadfailed'));
  }
}
function DownloadMab()
{
  var mabName = document.getElementById( "DownloadMabName" ).value;
  if (!mabName) return;

  var cn = directory.childNodes;
  var aBook = cn.getNext();
  var mabFile='';

  var cur=getAddressBook(mabName);
  if (cur) {
    mabFile=cur.directoryProperties.fileName;
//    if (uri==kPersonalAddressbookURI || uri==kCollectedAddressbookURI) {
//      alert(strings.getString('nooverwrite'));
//      return;
//    }
    if (!confirm(strings.getString('askoverwrite'))) return;
  } else {
    //create mabFile name
    mabFile = mabName.replace( /\W/g, "_" );
    mabFile += '.mab';
    createAddressBook( mabName, mabFile, false );
    init(true);
  }

  document.getElementById( "DownloadMabFile" ).value=mabFile;
  var w=window.open("chrome://addressbookssync/content/download.xul","_blank",'chrome,resizable,titlebar=no');
}

function get_password(host, user){
    var dhost= new Object();
    var duser= new Object();
    var pass= new Object();
    try{
      var pmInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                      .createInstance(Components.interfaces.nsIPasswordManagerInternal);
      var ret=pmInternal.findPasswordEntry(host,user,"",dhost,duser,pass);
      return pass.value;
    }catch(e){}
    return "";
}

function set_password(host, user, pwd){
//alert('set_password');
    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .createInstance(Components.interfaces.nsIPasswordManager);
    try{
      passwordManager.removeUser(host,user);
    }catch(e){}
    passwordManager.addUser(host,user,pwd);
}

function uploadNow()
{
  finish(); //ggf genderte Parameter bernehmen!
  if (pref.getCharPref( "extensions.addressbookssync.synctype")!='none')
    showPopup('upload', true);
}

function downloadNow()
{
  finish(); //ggf genderte Parameter bernehmen!
  if (pref.getCharPref( "extensions.addressbookssync.synctype")!='none')
    showPopup('download', true);
}
